// Generated by CoffeeScript 1.10.0
(function() {
  var abbrs, calculator, dual, getName, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  calculator = require('./common/calculator');

  dual = require('./common/dual');

  abbrs = {
    CAPC: ['capacitor'],
    RESC: ['resistor'],
    RESDFN: ['resistor', 'no-lead'],
    RESMELF: ['resistor', 'melf'],
    RESM: ['resistor', 'molded'],
    RESSC: ['resistor', 'concave']
  };

  getName = function(element) {
    var abbr, abbrWeight, classes, keywords, name, weight;
    name = 'U';
    if (element.keywords == null) {
      return name;
    }
    keywords = element.keywords.replace(/\s+/g, '').split(',');
    abbrWeight = 0;
    for (abbr in abbrs) {
      classes = abbrs[abbr];
      weight = keywords.filter((function(_this) {
        return function(a) {
          return classes.indexOf(a) !== -1;
        };
      })(this)).length;
      if (weight > abbrWeight) {
        abbrWeight = weight;
        name = abbr;
      }
    }
    return name;
  };

  module.exports = function(pattern, element) {
    var bodyLength, bodyWidth, courtyard, d, height, housing, lineWidth, pad, padParams, ref, settings, x, y;
    housing = element.housing;
    height = (ref = housing.height.max) != null ? ref : housing.height;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["%s%02d%02dX%d", getName(element)].concat(slice.call([housing.bodyLength.nom * 10, housing.bodyWidth.nom * 10, height * 100].map((function(_this) {
        return function(a) {
          return Math.round(a);
        };
      })(this)))));
    }
    settings = pattern.settings;
    padParams = calculator.chip(pattern, housing);
    pad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width,
      height: padParams.height,
      layer: ['topCopper', 'topMask', 'topPaste'],
      x: -padParams.distance / 2,
      y: 0
    };
    pattern.pad(1, pad);
    pad.x = -pad.x;
    pattern.pad(2, pad);
    lineWidth = settings.lineWidth.silkscreen;
    bodyWidth = housing.bodyWidth.nom;
    bodyLength = housing.bodyLength.nom;
    x = bodyLength / 2;
    y = padParams.height / 2 + lineWidth / 2 + settings.clearance.padToSilk;
    pattern.layer('topSilkscreen').lineWidth(lineWidth).attribute('refDes', {
      x: 0,
      y: 0,
      halign: 'center',
      valign: 'center'
    }).line(-x, -y, x, -y).line(-x, y, x, y);
    x = bodyLength / 2;
    y = bodyWidth / 2;
    d = 1;
    pattern.layer('topAssembly').lineWidth(settings.lineWidth.assembly).attribute('value', {
      text: pattern.name,
      x: 0,
      y: y + settings.fontSize.value / 2 + 0.5,
      halign: 'center',
      valign: 'center',
      visible: false
    }).rectangle(-x, -y, x, y);
    courtyard = padParams.courtyard;
    x = (padParams.width + padParams.distance) / 2 + courtyard;
    y = padParams.height / 2 + courtyard;
    return pattern.layer('topCourtyard').lineWidth(settings.lineWidth.courtyard).circle(0, 0, 0.5).line(-0.7, 0, 0.7, 0).line(0, -0.7, 0, 0.7).rectangle(-x, -y, x, y);
  };

}).call(this);
