// Generated by CoffeeScript 1.10.0
(function() {
  module.exports = {
    bga: function(pattern, housing) {
      var adj, courtyard, padSize, roundOff, settings;
      settings = pattern.settings;
      adj = settings.ball.collapsible ? 0.8 : 1;
      padSize = housing.leadSize.nom * adj;
      roundOff = 0.01;
      padSize = Math.round(padSize / roundOff) * roundOff;
      courtyard = housing.pitch * 0.8;
      roundOff = 0.05;
      courtyard = Math.round(courtyard / roundOff) * roundOff;
      return {
        width: padSize,
        height: padSize,
        courtyard: courtyard
      };
    },
    chip: function(pattern, housing) {
      var courtyard, heel, height, ipc, pad, params, ref, ref1, ref2, ref3, settings, side, toe;
      if (housing.leadWidth == null) {
        housing.leadWidth = housing.bodyWidth;
      }
      if (housing.leadSpan == null) {
        housing.leadSpan = housing.bodyLength;
      }
      settings = pattern.settings;
      height = (ref = housing.height.nom) != null ? ref : housing.height;
      toe = height * 0.5;
      heel = height * 0.1;
      side = height * 0.15;
      params = {
        Tmin: housing.leadLength.min,
        Tmax: housing.leadLength.max,
        Wmin: housing.leadWidth.min,
        Wmax: housing.leadWidth.max,
        F: settings.tolerance.fabrication,
        P: settings.tolerance.placement,
        Jt: (ref1 = pattern.toe) != null ? ref1 : toe,
        Jh: (ref2 = pattern.heel) != null ? ref2 : heel,
        Js: (ref3 = pattern.side) != null ? ref3 : side,
        Lmin: housing.leadSpan.min,
        Lmax: housing.leadSpan.max
      };
      ipc = this._ipc7351(params);
      if (ipc.Gmin < settings.clearance.padToPad) {
        ipc.Gmin = settings.clearance.padToPad;
      }
      pad = this._pad(ipc, pattern);
      courtyard = height * 0.4;
      courtyard = Math.round(courtyard / 0.01) * 0.01;
      if (courtyard > 0.25) {
        courtyard = 0.25;
      }
      pad.courtyard = courtyard;
      return pad;
    },
    qfn: function(pattern, housing) {
      var ipc1, ipc2, pad1, pad2, params, settings, trimmed;
      params = this._nolead(pattern, housing);
      params.Lmin = housing.bodyWidth.min;
      params.Lmax = housing.bodyWidth.max;
      if (housing.pullBack != null) {
        params.Lmin -= 2 * housing.pullBack;
        params.Lmax -= 2 * housing.pullBack;
      }
      ipc1 = this._ipc7351(params);
      params.Lmin = housing.bodyLength.min;
      params.Lmax = housing.bodyLength.max;
      if (housing.pullBack != null) {
        params.Lmin -= 2 * housing.pullBack;
        params.Lmax -= 2 * housing.pullBack;
      }
      ipc2 = this._ipc7351(params);
      trimmed = false;
      pad1 = this._pad(ipc1, pattern);
      pad2 = this._pad(ipc2, pattern);
      settings = pattern.settings;
      if (pad1.height > housing.pitch - settings.clearance.padToPad) {
        pad1.height = housing.pitch - settings.clearance.padToPad;
        trimmed = true;
      }
      if (pad2.height > housing.pitch - settings.clearance.padToPad) {
        pad2.height = housing.pitch - settings.clearance.padToPad;
        trimmed = true;
      }
      return {
        width1: pad1.width,
        height1: pad1.height,
        distance1: pad1.distance,
        width2: pad2.width,
        height2: pad2.height,
        distance2: pad2.distance,
        trimmed: trimmed,
        courtyard: {
          L: 0.12,
          N: 0.25,
          M: 0.50
        }[settings.densityLevel]
      };
    },
    qfp: function(pattern, housing) {
      var ipc1, ipc2, pad1, pad2, params, settings, trimmed;
      params = this._gullwing(pattern, housing);
      params.Lmin = housing.rowSpan.min;
      params.Lmax = housing.rowSpan.max;
      ipc1 = this._ipc7351(params);
      params.Lmin = housing.columnSpan.min;
      params.Lmax = housing.columnSpan.max;
      ipc2 = this._ipc7351(params);
      trimmed = false;
      if (ipc1.Gmin < (housing.bodyWidth.nom - 0.1)) {
        ipc1.Gmin = housing.bodyWidth.nom - 0.1;
        trimmed = true;
      }
      if (ipc2.Gmin < (housing.bodyLength.nom - 0.1)) {
        ipc2.Gmin = housing.bodyLength.nom - 0.1;
        trimmed = true;
      }
      pad1 = this._pad(ipc1, pattern);
      pad2 = this._pad(ipc2, pattern);
      settings = pattern.settings;
      if (pad1.height > housing.pitch - settings.clearance.padToPad) {
        pad1.height = housing.pitch - settings.clearance.padToPad;
        trimmed = true;
      }
      if (pad2.height > housing.pitch - settings.clearance.padToPad) {
        pad2.height = housing.pitch - settings.clearance.padToPad;
        trimmed = true;
      }
      return {
        width1: pad1.width,
        height1: pad1.height,
        distance1: pad1.distance,
        width2: pad2.width,
        height2: pad2.height,
        distance2: pad2.distance,
        trimmed: trimmed,
        courtyard: {
          L: 0.12,
          N: 0.25,
          M: 0.50
        }[settings.densityLevel]
      };
    },
    sop: function(pattern, housing) {
      var ipc, pad, params, settings, trimmed;
      params = this._gullwing(pattern, housing);
      params.Lmin = housing.leadSpan.min;
      params.Lmax = housing.leadSpan.max;
      ipc = this._ipc7351(params);
      trimmed = false;
      if (ipc.Gmin < (housing.bodyWidth.nom - 0.1)) {
        ipc.Gmin = housing.bodyWidth.nom - 0.1;
        trimmed = true;
      }
      pad = this._pad(ipc, pattern);
      settings = pattern.settings;
      if (pad.height > housing.pitch - settings.clearance.padToPad) {
        pad.height = housing.pitch - settings.clearance.padToPad;
        trimmed = true;
      }
      pad.trimmed = trimmed;
      pad.courtyard = {
        L: 0.12,
        N: 0.25,
        M: 0.50
      }[settings.densityLevel];
      return pad;
    },
    _gullwing: function(pattern, housing) {
      var heel, ref, ref1, ref2, settings, side, toe;
      settings = pattern.settings;
      toe = {
        L: 0.15,
        N: 0.35,
        M: 0.55
      };
      heel = {
        L: 0.25,
        N: 0.35,
        M: 0.45
      };
      side = housing.pitch > 0.625 ? {
        L: 0.01,
        N: 0.03,
        M: 0.05
      } : {
        L: -0.04,
        N: -0.02,
        M: 0.01
      };
      return {
        Tmin: housing.leadLength.min,
        Tmax: housing.leadLength.max,
        Wmin: housing.leadWidth.min,
        Wmax: housing.leadWidth.max,
        F: settings.tolerance.fabrication,
        P: settings.tolerance.placement,
        Jt: (ref = pattern.toe) != null ? ref : toe[settings.densityLevel],
        Jh: (ref1 = pattern.heel) != null ? ref1 : heel[settings.densityLevel],
        Js: (ref2 = pattern.side) != null ? ref2 : side[settings.densityLevel]
      };
    },
    _ipc7351: function(params) {
      var Cl, Cs, Cw, F, Jh, Js, Jt, Lmax, Lmin, Ltol, P, Smax, SmaxRms, Smin, Stol, StolRms, Tmax, Tmin, Ttol, Wmax, Wmin, Wtol;
      Lmin = params.Lmin;
      Lmax = params.Lmax;
      Ltol = Lmax - Lmin;
      Tmin = params.Tmin;
      Tmax = params.Tmax;
      Ttol = Tmax - Tmin;
      Wmin = params.Wmin;
      Wmax = params.Wmax;
      Wtol = Wmax - Wmin;
      F = params.F;
      P = params.P;
      Jt = params.Jt;
      Jh = params.Jh;
      Js = params.Js;
      Smin = Lmin - 2 * Tmax;
      Smax = Lmax - 2 * Tmin;
      Stol = Ltol + 2 * Ttol;
      StolRms = Math.sqrt(Ltol * Ltol + 2 * Ttol * Ttol);
      SmaxRms = Smax - (Stol - StolRms) / 2;
      Cl = Ltol;
      Cs = StolRms;
      Cw = Wtol;
      return {
        Zmax: Lmin + 2 * Jt + Math.sqrt(Cl * Cl + F * F + P * P),
        Gmin: SmaxRms - 2 * Jh - Math.sqrt(Cs * Cs + F * F + P * P),
        Xmax: Wmin + 2 * Js + Math.sqrt(Cw * Cw + F * F + P * P)
      };
    },
    _nolead: function(pattern, housing) {
      var heel, ref, ref1, ref2, settings, side, toe;
      settings = pattern.settings;
      toe = housing.pullBack != null ? 0.0 : {
        L: 0.20,
        N: 0.30,
        M: 0.40
      }[settings.densityLevel];
      heel = 0.0;
      side = housing.pullBack != null ? 0.0 : -0.04;
      return {
        Tmin: housing.leadLength.min,
        Tmax: housing.leadLength.max,
        Wmin: housing.leadWidth.min,
        Wmax: housing.leadWidth.max,
        F: settings.tolerance.fabrication,
        P: settings.tolerance.placement,
        Jt: (ref = pattern.toe) != null ? ref : toe,
        Jh: (ref1 = pattern.heel) != null ? ref1 : heel,
        Js: (ref2 = pattern.side) != null ? ref2 : side
      };
    },
    _pad: function(ipc, pattern) {
      var padDistance, padHeight, padWidth, placeRoundoff, ref, ref1, sizeRoundoff;
      padWidth = (ipc.Zmax - ipc.Gmin) / 2;
      padHeight = ipc.Xmax;
      padDistance = (ipc.Zmax + ipc.Gmin) / 2;
      sizeRoundoff = (ref = pattern.sizeRoundoff) != null ? ref : 0.05;
      placeRoundoff = (ref1 = pattern.placeRoundoff) != null ? ref1 : 0.1;
      padWidth = Math.round(padWidth / sizeRoundoff) * sizeRoundoff;
      padHeight = Math.round(padHeight / sizeRoundoff) * sizeRoundoff;
      padDistance = Math.round(padDistance / placeRoundoff) * placeRoundoff;
      return {
        width: padWidth,
        height: padHeight,
        distance: padDistance
      };
    }
  };

}).call(this);
