// Generated by CoffeeScript 1.10.0
(function() {
  var calculator, quad, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  calculator = require('./common/calculator');

  quad = require('./common/quad');

  module.exports = function(pattern, element) {
    var bodyLength, bodyWidth, courtyard, d, firstPad, hasTab, height, housing, lastPad, leadCount, lineWidth, padParams, r, ref, ref1, ref2, settings, tabNumber, tabPad, x, x1, y, y1;
    housing = element.housing;
    leadCount = (ref = housing.leadCount) != null ? ref : 2 * (housing.rowCount + housing.columnCount);
    hasTab = (housing.tabWidth != null) && (housing.tabLength != null);
    if (hasTab) {
      ++leadCount;
    }
    height = (ref1 = housing.height.max) != null ? ref1 : housing.height;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["%sQFN%dP%dX%dX%d-%d", housing.pullBack != null ? 'P' : ''].concat(slice.call([housing.pitch * 100, housing.bodyLength.nom * 100, housing.bodyWidth.nom * 100, height * 100, leadCount].map((function(_this) {
        return function(a) {
          return Math.round(a);
        };
      })(this)))));
    }
    settings = pattern.settings;
    padParams = calculator.qfn(pattern, housing);
    padParams.pitch = housing.pitch;
    padParams.rowCount = housing.rowCount;
    padParams.columnCount = housing.columnCount;
    padParams.rowPad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width1,
      height: padParams.height1,
      distance: padParams.distance1,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    padParams.columnPad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.height2,
      height: padParams.width2,
      distance: padParams.distance2,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    quad(pattern, padParams);
    if (hasTab) {
      if (housing.tabOffset == null) {
        housing.tabOffset = '0, 0';
      }
      ref2 = housing.tabOffset.replace(/\s+/g, '').split(',').map((function(_this) {
        return function(a) {
          return parseFloat(a);
        };
      })(this)), x = ref2[0], y = ref2[1];
      tabNumber = leadCount;
      tabPad = {
        type: 'smd',
        shape: 'rectangle',
        width: housing.tabWidth.nom,
        height: housing.tabLength.nom,
        layer: ['topCopper', 'topMask', 'topPaste'],
        x: x,
        y: y
      };
      pattern.pad(tabNumber, tabPad);
    }
    firstPad = pattern.pads[1];
    lastPad = pattern.pads[2 * (padParams.rowCount + padParams.columnCount)];
    lineWidth = settings.lineWidth.silkscreen;
    bodyWidth = housing.bodyWidth.nom;
    bodyLength = housing.bodyLength.nom;
    x = -bodyWidth / 2 - lineWidth / 2;
    y = -bodyLength / 2 - lineWidth / 2;
    x1 = lastPad.x - lastPad.width / 2 - lineWidth / 2 - settings.clearance.padToSilk;
    if (x > x1) {
      x = x1;
    }
    y1 = firstPad.y - firstPad.height / 2 - lineWidth / 2 - settings.clearance.padToSilk;
    if (y > y1) {
      y = y1;
    }
    pattern.layer('topSilkscreen').lineWidth(lineWidth).attribute('refDes', {
      x: 0,
      y: 0,
      halign: 'center',
      valign: 'center'
    }).moveTo(x1, y).lineTo(x, y).moveTo(-x1, y).lineTo(-x, y).lineTo(-x, y1).moveTo(x1, -y).lineTo(x, -y).lineTo(x, -y1).moveTo(-x1, -y).lineTo(-x, -y).lineTo(-x, -y1);
    if (settings.polarityMark === 'dot') {
      r = 0.25;
      x = firstPad.x - firstPad.width / 2 - r - settings.clearance.padToSilk;
      y = firstPad.y;
      pattern.lineWidth(r).circle(x, y, r / 2);
    }
    x = bodyWidth / 2;
    y = bodyLength / 2;
    d = 1;
    pattern.layer('topAssembly').lineWidth(settings.lineWidth.assembly).attribute('value', {
      text: pattern.name,
      x: 0,
      y: y + settings.fontSize.value / 2 + 0.5,
      halign: 'center',
      valign: 'center',
      visible: false
    }).moveTo(-x + d, -y).lineTo(x, -y).lineTo(x, y).lineTo(-x, y).lineTo(-x, -y + d).lineTo(-x + d, -y);
    courtyard = padParams.courtyard;
    x = Math.min(-bodyWidth / 2, firstPad.x - firstPad.width / 2) - courtyard;
    y = Math.min(-bodyLength / 2, lastPad.y - lastPad.height / 2) - courtyard;
    return pattern.layer('topCourtyard').lineWidth(settings.lineWidth.courtyard).circle(0, 0, 0.5).line(-0.7, 0, 0.7, 0).line(0, -0.7, 0, 0.7).rectangle(-x, -y, x, y);
  };

}).call(this);
