// Generated by CoffeeScript 1.10.0
(function() {
  var calculator, quad, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  calculator = require('./common/calculator');

  quad = require('./common/quad');

  module.exports = function(pattern, element) {
    var bodyLength, bodyWidth, courtyard, d, firstPad, height, housing, lastPad, leadCount, lineWidth, padParams, r, ref, ref1, settings, x, x1, x2, y, y1, y2;
    housing = element.housing;
    leadCount = (ref = housing.leadCount) != null ? ref : 2 * (housing.rowCount + housing.columnCount);
    height = (ref1 = housing.height.max) != null ? ref1 : housing.height;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["QFP%dP%dX%dX%d-%d"].concat(slice.call([housing.pitch * 100, housing.rowSpan.nom * 100, housing.columnSpan.nom * 100, height * 100, leadCount].map((function(_this) {
        return function(a) {
          return Math.round(a);
        };
      })(this)))));
    }
    settings = pattern.settings;
    padParams = calculator.qfp(pattern, housing);
    padParams.pitch = housing.pitch;
    padParams.rowCount = housing.rowCount;
    padParams.columnCount = housing.columnCount;
    padParams.rowPad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width1,
      height: padParams.height1,
      distance: padParams.distance1,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    padParams.columnPad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.height2,
      height: padParams.width2,
      distance: padParams.distance2,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    quad(pattern, padParams);
    firstPad = pattern.pads[1];
    lastPad = pattern.pads[2 * (padParams.rowCount + padParams.columnCount)];
    lineWidth = settings.lineWidth.silkscreen;
    bodyWidth = housing.bodyWidth.nom;
    bodyLength = housing.bodyLength.nom;
    x = -bodyWidth / 2 - lineWidth / 2;
    y = -bodyLength / 2 - lineWidth / 2;
    x1 = lastPad.x - lastPad.width / 2 - lineWidth / 2 - settings.clearance.padToSilk;
    if (x > x1) {
      x = x1;
    }
    y1 = firstPad.y - firstPad.height / 2 - lineWidth / 2 - settings.clearance.padToSilk;
    if (y > y1) {
      y = y1;
    }
    pattern.layer('topSilkscreen').lineWidth(lineWidth).attribute('refDes', {
      x: 0,
      y: 0,
      halign: 'center',
      valign: 'center'
    }).moveTo(x1, y).lineTo(x, y).lineTo(x, y1).lineTo(x - firstPad.width, y1).moveTo(-x1, y).lineTo(-x, y).lineTo(-x, y1).moveTo(x1, -y).lineTo(x, -y).lineTo(x, -y1).moveTo(-x1, -y).lineTo(-x, -y).lineTo(-x, -y1);
    if (settings.polarityMark === 'dot') {
      r = 0.25;
      x = firstPad.x - firstPad.width / 2 - r - settings.clearance.padToSilk;
      y = firstPad.y;
      pattern.lineWidth(r).circle(x, y, r / 2);
    }
    x = bodyWidth / 2;
    y = bodyLength / 2;
    d = 1;
    pattern.layer('topAssembly').lineWidth(settings.lineWidth.assembly).attribute('value', {
      text: pattern.name,
      x: 0,
      y: y + settings.fontSize.value / 2 + 0.5,
      halign: 'center',
      valign: 'center',
      visible: false
    }).moveTo(-x + d, -y).lineTo(x, -y).lineTo(x, y).lineTo(-x, y).lineTo(-x, -y + d).lineTo(-x + d, -y);
    courtyard = padParams.courtyard;
    x = -bodyWidth / 2 - courtyard;
    y = -bodyLength / 2 - courtyard;
    x1 = firstPad.x - firstPad.width / 2 - courtyard;
    y1 = firstPad.y - firstPad.height / 2 - courtyard;
    x2 = lastPad.x - lastPad.width / 2 - courtyard;
    y2 = lastPad.y - lastPad.height / 2 - courtyard;
    return pattern.layer('topCourtyard').lineWidth(settings.lineWidth.courtyard).circle(0, 0, 0.5).line(-0.7, 0, 0.7, 0).line(0, -0.7, 0, 0.7).moveTo(x1, y1).lineTo(x, y1).lineTo(x, y).lineTo(x2, y).lineTo(x2, y2).lineTo(-x2, y2).lineTo(-x2, y).lineTo(-x, y).lineTo(-x, y1).lineTo(-x1, y1).lineTo(-x1, -y1).lineTo(-x, -y1).lineTo(-x, -y).lineTo(-x2, -y).lineTo(-x2, -y2).lineTo(x2, -y2).lineTo(x2, -y).lineTo(x, -y).lineTo(x, -y1).lineTo(x1, -y1).lineTo(x1, y1);
  };

}).call(this);
