// Generated by CoffeeScript 1.10.0
(function() {
  var QedaSymbol,
    hasProp = {}.hasOwnProperty;

  QedaSymbol = (function() {
    function QedaSymbol(element, groups1, name1) {
      var both, delta, group, groups, i, j, len, len1, pinGroup, schematic, side, sides, toLeft, toRight;
      this.groups = groups1;
      this.name = name1;
      this.settings = element.library.symbol;
      this.shapes = [];
      this.attributes = [];
      this.currentLineWidth = 0;
      sides = ['left', 'right', 'top', 'bottom'];
      schematic = element.schematic;
      for (i = 0, len = sides.length; i < len; i++) {
        side = sides[i];
        this[side] = [];
        if (schematic[side] != null) {
          groups = element.parseMultiple(schematic[side]);
          for (j = 0, len1 = groups.length; j < len1; j++) {
            group = groups[j];
            pinGroup = element.pinGroups[group];
            if ((this.groups.indexOf(group) !== -1) && (pinGroup != null)) {
              if (this[side].length > 0) {
                this[side].push('-');
              }
              this[side] = this[side].concat(pinGroup);
            }
          }
        }
      }
      both = this.left.filter((function(_this) {
        return function(a) {
          return (a !== '-') && (_this.right.indexOf(a) !== -1);
        };
      })(this));
      delta = Math.ceil((this.right.length - this.left.length + both.length) / 2);
      toLeft = both.slice(0, +(delta - 1) + 1 || 9e9);
      toRight = both.slice(delta);
      this.left = this.left.filter((function(_this) {
        return function(a) {
          return toRight.indexOf(a) === -1;
        };
      })(this));
      this.right = this.right.filter((function(_this) {
        return function(a) {
          return toLeft.indexOf(a) === -1;
        };
      })(this));
    }

    QedaSymbol.prototype.attribute = function(name, attribute) {
      var ref;
      attribute.name = name;
      if (attribute.fontSize == null) {
        attribute.fontSize = (ref = this.settings.fontSize[name]) != null ? ref : this.settings.fontSize["default"];
      }
      this.attributes[name] = this._addShape('attribute', attribute);
      return this;
    };

    QedaSymbol.prototype.circle = function(x, y, radius) {
      this._addShape('circle', {
        x: x,
        y: y,
        radius: radius
      });
      return this;
    };

    QedaSymbol.prototype.invertVertical = function() {
      var i, len, prop, props, ref, results, shape;
      props = ['y', 'y1', 'y2', 'height'];
      ref = this.shapes;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        shape = ref[i];
        results.push((function() {
          var j, len1, results1;
          results1 = [];
          for (j = 0, len1 = props.length; j < len1; j++) {
            prop = props[j];
            if (shape[prop] != null) {
              results1.push(shape[prop] *= -1);
            } else {
              results1.push(void 0);
            }
          }
          return results1;
        })());
      }
      return results;
    };

    QedaSymbol.prototype.line = function(x1, y1, x2, y2) {
      this._addShape('line', {
        x1: x1,
        y1: y1,
        x2: x2,
        y2: y2
      });
      return this;
    };

    QedaSymbol.prototype.lineWidth = function(lineWidth) {
      this.currentLineWidth = lineWidth;
      return this;
    };

    QedaSymbol.prototype.pin = function(pin) {
      if (pin.fontSize == null) {
        pin.fontSize = this.settings.fontSize.pin;
      }
      if (pin.space == null) {
        pin.space = this.settings.space.pin;
      }
      this._addShape('pin', pin);
      return this;
    };

    QedaSymbol.prototype.rectangle = function(x1, y1, x2, y2, fill) {
      if (fill == null) {
        fill = 'none';
      }
      this._addShape('rectangle', {
        x1: x1,
        y1: y1,
        x2: x2,
        y2: y2,
        fill: fill
      });
      return this;
    };

    QedaSymbol.prototype.resize = function(gridSize, needRound) {
      var factor, i, len, prop, props, ref, results, shape, value;
      if (needRound == null) {
        needRound = false;
      }
      factor = gridSize / this.settings.gridSize;
      props = ['x', 'x1', 'x2', 'y', 'y1', 'y2', 'width', 'height', 'length', 'lineWidth', 'fontSize', 'space', 'radius'];
      ref = this.shapes;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        shape = ref[i];
        results.push((function() {
          var j, len1, results1;
          results1 = [];
          for (j = 0, len1 = props.length; j < len1; j++) {
            prop = props[j];
            if (shape[prop] != null) {
              value = shape[prop] * factor;
              if (needRound) {
                value = Math.round(value);
              }
              results1.push(shape[prop] = value);
            } else {
              results1.push(void 0);
            }
          }
          return results1;
        })());
      }
      return results;
    };

    QedaSymbol.prototype.textWidth = function(text, textType) {
      if (textType == null) {
        textType = 'default';
      }
      return this.settings.fontSize[textType] * text.length;
    };

    QedaSymbol.prototype._addShape = function(kind, shape) {
      var obj, prop;
      obj = {
        kind: kind
      };
      for (prop in shape) {
        if (!hasProp.call(shape, prop)) continue;
        obj[prop] = shape[prop];
      }
      if (obj.lineWidth == null) {
        obj.lineWidth = this.currentLineWidth;
      }
      this.shapes.push(obj);
      return obj;
    };

    return QedaSymbol;

  })();

  module.exports = QedaSymbol;

}).call(this);
